/*	
 *	clipshya.c
 *
 *	ԏASY
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2014 Naoyuki Sawa
 *
 *	* Wed May 14 22:25:54 JST 2014 Naoyuki Sawa
 *	- 1st[XB
 */
#include "clip.h"

/****************************************************************************
 *	ԏASY
 ****************************************************************************/
void ShuntingYard(const ST_ShuntingYard* pShuntingYard, const int* aInput, int* aOutput, void* pParam) {
	/* Ql:uhttp://ja.wikipedia.org/wiki/ԏASYv */
	int aStack[32/**/];
	int iStackTop = -1;
	int iToken;
	/* g[N1ǂݍށB */
	while((iToken = *aInput++)) {
		/* g[N̎ނɂāc */
		switch((*pShuntingYard->fnGetTokenType)(iToken, pParam)) {
		/* l */
		case ShuntingYard_TokenType_Number:
			/* lAo̓L[ɒǉB */
			*aOutput++ = iToken;
			break;
		/* ֐,, */
		case ShuntingYard_TokenType_Function:
		case ShuntingYard_TokenType_LeftParenthesis:
			/* ֐,,ʂAX^bNɃvbVB */
			if(++iStackTop >= ARRAY_SIZE(aStack)) { DIE(); }
			aStack[iStackTop] = iToken;
			break;
		/* ֐̈Zp[^(J}Ȃ) */
		case ShuntingYard_TokenType_FunctionArgumentSeparator:
			/* X^bÑgbvɂg[NʂƂȂ܂ŁAX^bN牉Zq(,֐)|bvďo̓L[ɒǉ铮JԂB
			 * ʂoĂȂꍇAZp[^̈ʒuAE̊ʂsvƂȂĂ(G[)B */
			for(;;) {
				if(iStackTop < 0) { DIE(); }
				if((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_LeftParenthesis) { break; }
				if(((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) != ShuntingYard_TokenType_Function) &&
				   ((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) != ShuntingYard_TokenType_Operator)) { DIE(); }
				*aOutput++ = aStack[iStackTop--];
			}
			break;
		/* Zq */
		case ShuntingYard_TokenType_Operator:
			/* X^bÑgbvɉZqg[No2Ao1,,D揇ʂo2ƓႢꍇA邢́Ao1̗D揇ʂo2ႢꍇAȉJԂB
			 * - o2X^bN|bvAo̓L[ɒǉB
			 * o1X^bNɃvbVB */
			while((iStackTop >= 0) &&								//X^bÑgbvɉZqg[No2A
			     (((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_Operator) &&
			     (((*pShuntingYard->fnIsOpLeftAssoc)(iToken, pParam) &&				//o1,,D揇ʂo2ƓႢꍇA
			     ((*pShuntingYard->fnCompareOpPrec)(iToken, aStack[iStackTop], pParam) <= 0)) ||
			     ((*pShuntingYard->fnCompareOpPrec)(iToken, aStack[iStackTop], pParam) < 0)))) {	//邢́Ao1̗D揇ʂo2ႢꍇA
				*aOutput++ = aStack[iStackTop--];
			}
			if(++iStackTop >= ARRAY_SIZE(aStack)) { DIE(); }
			aStack[iStackTop] = iToken;
			break;
		/* E */
		case ShuntingYard_TokenType_RightParenthesis:
			/* X^bÑgbvɂg[NʂɂȂ܂ŁAX^bN|bvZq(,֐)o̓L[ɒǉ铮JԂB
			 * ʂX^bN|bv邪Ao͂ɂ͒ǉɎ̂ĂB
			 * X^bÑgbvɂg[N֐g[NȂA|bvďo̓L[ɒǉB
			 * ʂX^bNɌȂꍇAE̊ʂ̕sv(G[)B */
			for(;;) {
				if(iStackTop < 0) { DIE(); }
				if((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_LeftParenthesis) { break; }
				if(((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) != ShuntingYard_TokenType_Function) &&
				   ((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) != ShuntingYard_TokenType_Operator)) { DIE(); }
				*aOutput++ = aStack[iStackTop--];
			}
			iStackTop--;		//ʂX^bN|bv邪Ao͂ɂ͒ǉɎ̂ĂB
			if((iStackTop >= 0) &&	//X^bÑgbvɂg[N֐g[NȂA|bvďo̓L[ɒǉB
			  ((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_Function)) {
				*aOutput++ = aStack[iStackTop--];
			}
			break;
		default:
			DIE();
		}
	}
	/* X^bNɉZqg[NԁAȉJԂB
	 * - X^bÑgbvɂ鉉Zqg[NʂȂAʂ̕sv(G[)B
	 * - ZqX^bN|bvďo̓L[ɒǉB */
	while(iStackTop >= 0) {
		if(((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_LeftParenthesis ) ||
		   ((*pShuntingYard->fnGetTokenType)(aStack[iStackTop], pParam) == ShuntingYard_TokenType_RightParenthesis)) { DIE(); }
		*aOutput++ = aStack[iStackTop--];
	}
	*aOutput = 0;	//o̓L[I[
}

/****************************************************************************
 *	Tv
 ****************************************************************************/
/* - ԏASY𗘗pāAeLXǧvZsTvłB
 *   Tvł͂܂A͂ŗplƎv̂ŁAAvP[Vp\ɂ܂B
 * - ̃Tvł́AP̂߁Al̂܂܃g[NlƂ܂B
 *   ۂɂ́AX̃g[Nێ郁mۂāA(int)ɃLXgāAg[NlƂׂłB
 */
/*---------------------------------------------------------------------------*/
/* ̃TvΉĂ鎮̗vf */
enum {
	op_umi=INT_MIN,	//Zq:-(P)
	op_pow,		//Zq:^
	op_add,		//Zq:+
	op_sub,		//Zq:-()
	op_mul,		//Zq:*
	op_div,		//Zq:/
	fn_abs,		//֐:abs
	fn_mod,		//֐:mod
	fn_sep,		//֐̈Zp[^(J}Ȃ):,
	lf_par,		//:(
	ri_par,		//E:)
	nu_min,		//l							//l(0)˃g[N(nu_min)ɃGR[h
};
/*---------------------------------------------------------------------------*/
/* eLXg𒆒uL@̃g[Nтɕϊ */
static void ShuntingYard_PreProcess(const char* pText, int* aInput) {
	int c, n, i = 0;
	while((c = *pText)) {
		if(isspace(c)) {
			pText++;
		} else if(isdigit(c)) {
			n = strtol(pText, (char**)&pText, 0);
			if(n <= nu_min) { DIE(); }
			aInput[i++] = n ? n : nu_min;				//l(0)˃g[N(nu_min)ɃGR[h
		} else if(!strncmp(pText, "abs", 3)) {
			pText += 3;
			aInput[i++] = fn_abs;
			continue;
		} else if(!strncmp(pText, "mod", 3)) {
			pText += 3;
			aInput[i++] = fn_mod;
			continue;
		} else {
			switch(c) {
			case '^': pText++; aInput[i++] = op_pow; break;
			case '+': pText++; aInput[i++] = op_add; break;
			case '-': if(i && (aInput[i-1] >= ri_par)) {
				  pText++; aInput[i++] = op_sub; } else {
				  pText++; aInput[i++] = op_umi; } break;
			case '*': pText++; aInput[i++] = op_mul; break;
			case '/': pText++; aInput[i++] = op_div; break;
			case ',': pText++; aInput[i++] = fn_sep; break;
			case '(': pText++; aInput[i++] = lf_par; break;
			case ')': pText++; aInput[i++] = ri_par; break;
			default: DIE();
			}
		}
	}
	aInput[i] = 0;
}
/*---------------------------------------------------------------------------*/
/* t|[hL@̃g[NтvZ */
static int ShuntingYard_PostProcess(const int* aOutput) {
	int aStack[32/**/];
	int iStackTop = -1;
	int iToken;
	while((iToken = *aOutput++)) {
		switch(iToken) {
		case op_umi:	//Zq:-(P)
			if(iStackTop < 0) { DIE(); }
			aStack[iStackTop] = -aStack[iStackTop];
			break;
		case op_pow:	//Zq:^
			if(iStackTop < 1) { DIE(); }
			aStack[iStackTop - 1] = (int)pow(aStack[iStackTop - 1], aStack[iStackTop]);
			iStackTop--;
			break;
		case op_add:	//Zq:+
			if(iStackTop < 1) { DIE(); }
			aStack[iStackTop - 1] = aStack[iStackTop - 1] + aStack[iStackTop];
			iStackTop--;
			break;
		case op_sub:	//Zq:-()
			if(iStackTop < 1) { DIE(); }
			aStack[iStackTop - 1] = aStack[iStackTop - 1] - aStack[iStackTop];
			iStackTop--;
			break;
		case op_mul:	//Zq:*
			if(iStackTop < 1) { DIE(); }
			aStack[iStackTop - 1] = aStack[iStackTop - 1] * aStack[iStackTop];
			iStackTop--;
			break;
		case op_div:	//Zq:/
			if(iStackTop < 1) { DIE(); }
			aStack[iStackTop - 1] = aStack[iStackTop - 1] / aStack[iStackTop];
			iStackTop--;
			break;
		case fn_abs:	//֐:abs
			if(iStackTop < 0) { DIE(); }
			aStack[iStackTop] = abs(aStack[iStackTop]);
			break;
		case fn_mod:	//֐:mod
			if((iStackTop < 1) || (aStack[iStackTop] < nu_min) || (aStack[iStackTop - 1] < nu_min)) { DIE(); }
			aStack[iStackTop - 1] = aStack[iStackTop - 1] % aStack[iStackTop];
			iStackTop--;
			break;
		case fn_sep:	//֐̈Zp[^(J}Ȃ):,
		case lf_par:	//:(
		case ri_par:	//E:)
			DIE();
		//case nu_min:	//l
		default:
			if(++iStackTop >= ARRAY_SIZE(aStack)) { DIE(); }
			aStack[iStackTop] = (iToken == nu_min) ? 0 : iToken;	//g[N(nu_min)ːl(0)ɃfR[h
			break;
		}
	}
	if((iStackTop != 0) || (aStack[iStackTop] < nu_min)) { DIE(); }
	return aStack[iStackTop];
}
/*---------------------------------------------------------------------------*/
/* AvP[V`̊֐:g[N̎ނԂ */
static int ShuntingYard_GetTokenType(int iToken, void* pParam) {
	switch(iToken) {
	case op_umi:	//Zq:-(P)
	case op_pow:	//Zq:^
	case op_add:	//Zq:+
	case op_sub:	//Zq:-()
	case op_mul:	//Zq:*
	case op_div:	//Zq:/
		return ShuntingYard_TokenType_Operator;
	case fn_abs:	//֐:abs
	case fn_mod:	//֐:mod
		return ShuntingYard_TokenType_Function;
	case fn_sep:	//֐̈Zp[^(J}Ȃ)
		return ShuntingYard_TokenType_FunctionArgumentSeparator;
	case lf_par:	//
		return ShuntingYard_TokenType_LeftParenthesis;
	case ri_par:	//E
		return ShuntingYard_TokenType_RightParenthesis;
	//case nu_min:	//l
	default:
		return ShuntingYard_TokenType_Number;
	}
}
/*---------------------------------------------------------------------------*/
/* AvP[V`̊֐:ZqԂ */
static int ShuntingYard_IsOpLeftAssoc(int iOpTok, void* pParam) {
	switch(iOpTok) {
	case op_umi:	//Zq:-(P)
	case op_pow:	//Zq:^
		return 0;
	case op_add:	//Zq:+
	case op_sub:	//Zq:-()
	case op_mul:	//Zq:*
	case op_div:	//Zq:/
		return 1;
	default: DIE();
	}
}
/*---------------------------------------------------------------------------*/
/* AvP[V`̊֐:Zq̗D揇ʂrׂ */
static int ShuntingYard_CompareOpPrec(int iOpTok1, int iOpTok2, void* pParam) {
	switch(iOpTok1) {
	case op_umi:	//Zq:-(P)
		iOpTok1 = 2; break;
	case op_pow:	//Zq:^
		iOpTok1 = 3; break;
	case op_add:	//Zq:+
	case op_sub:	//Zq:-()
		iOpTok1 = 0; break;
	case op_mul:	//Zq:*
	case op_div:	//Zq:/
		iOpTok1 = 1; break;
	default: DIE();
	}
	switch(iOpTok2) {
	case op_umi:	//Zq:-(P)
		iOpTok2 = 2; break;
	case op_pow:	//Zq:^
		iOpTok2 = 3; break;
	case op_add:	//Zq:+
	case op_sub:	//Zq:-()
		iOpTok2 = 0; break;
	case op_mul:	//Zq:*
	case op_div:	//Zq:/
		iOpTok2 = 1; break;
	default: DIE();
	}
	return iOpTok1 - iOpTok2;
}
/*---------------------------------------------------------------------------*/
/* ԏASY𗘗pāAeLXǧvZs */
int ShuntingYard_Eval(const char* pText) {
	static const ST_ShuntingYard stShuntingYard = {
		ShuntingYard_GetTokenType ,
		ShuntingYard_IsOpLeftAssoc,
		ShuntingYard_CompareOpPrec,
	};
	int aInput[64/**/], aOutput[64/**/];
	ShuntingYard_PreProcess(pText, aInput);				//eLXg˒uL@̃g[N
	ShuntingYard(&stShuntingYard, aInput, aOutput, NULL);		//uL@̃g[Nсˋt|[hL@̃g[N
	return ShuntingYard_PostProcess(aOutput);			//t|[hL@̃g[NсˌvZ
}
#if 0
void TestSuite() { //gp
	printf("%d\n", ShuntingYard_Eval("-10 + mod(-9,-abs(-10+5))^2")); //6
}
#endif
