/*
 *	dtinylz - TinyLZ compression tool
 *	Copyright (C) 2009 Naoyuki Sawa
 *
 *	* Sun Feb 17 14:57:30 JST 2008 Naoyuki Sawa
 *	- 1st [XB
 *	* Mon Nov 17 11:22:19 JST 2008 Naoyuki Sawa
 *	- gq".tlz"̎⊮[ύX܂B
 *	  ܂ł́AkÕt@C̊gq".tlz"ɒuĂ܂Ă̂ŁÅgq̏񂪎Ă܂B
 *	  ̕ύXŁAkÕt@C̊gqc܂".tlz"ǉ悤ɂ̂ŁÅgq̏񂪎c܂B
 *	  <>
 *		k: dtinylz -e fname.ext     (o̓t@Cȗ) -> o̓t@C fname.ext.tlz ɂȂ܂B
 *		WJ: dtinylz -d fname.ext.tlz (o̓t@Cȗ) -> o̓t@C fname.ext     ɂȂ܂B
 *	- ڍׂȎ⊮[́A\[X̃Rg"2008/11/17"ŌĎQƂĂB
 *	* Mon Mar 02 22:18:49 JST 2009 Naoyuki Sawa
 *	- cliptlz.cW[TinyLZ_compress()֐̎ύXɔAăRpC܂B
 *	  {W[(main.c)̃R[h́AύX܂B
 *	  ܂ATinyLZ_compress()֐̕ύXAo̓f[^͂܂łƕω܂B
 *	* Thu Aug 06 11:14:39 JST 2009 Naoyuki Sawa
 *	- t@CTCY20MBȏ̂ƂɁAǩvZI[o[t[āA}CiXl\Ă܂Ă܂B
 *	  ԈĂ̂̓|[g\ŁAkEWJt@Ĉ̂͊ԈĂ܂łB
 *	  ̔łŁAL̃oOCAk|[g\悤ɂ܂B
 *	* Wed Aug 26 01:30:42 JST 2009 Naoyuki Sawa
 *	- xt@CɁATCYrłȂAers悤C܂B
 *	  {vO͊ɏ[肵ĂAxt@C͂قǏdvł͂Ȃ̂łAÔ߂ɏCĂƂɂ܂B
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#define DIE() abort()
#define __CLIP_H__
#include "../../cliptlz.h"
#include "../../cliptlz.c"

#define VERSION "20090826"

/////////////////////////////////////////////////////////////////////////////

void
usage()
{
	printf("dtinylz - TinyLZ compression tool (%s) Naoyuki Sawa\n", VERSION);
	printf("Usage: [-d/-e] <source file name> [<destination file name>]\n");
	printf("Options:\n");
	printf("  -e : encode source file(default)\n");
	printf("  -d : decode source file\n");
	exit(1);
}

int mode; /* 'd' or 'e' */
char srcname[_MAX_PATH];
char dstname[_MAX_PATH];

int srclen;
unsigned char* srcbuf;
int dstlen;
unsigned char* dstbuf;
int verlen;
unsigned char* verbuf;

int
main(int argc, char* argv[])
{
	int i;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	FILE* fp;

	/* R}hĆB */
	for(i = 1; i < argc; i++) {
		switch(argv[i][0]) {
		case '-':
		case '/':
			switch(tolower(argv[i][1])) {
			case 'd':
			case 'e':
				if(!mode) {
					mode = tolower(argv[i][1]);
					break;
				}
				usage();
				break;
			default:
				usage();
				break;
			}
			break;
		default:
			if(!srcname[0]) {
				strcpy(srcname, argv[i]);
				break;
			}
			if(!dstname[0]) {
				strcpy(dstname, argv[i]);
				break;
			}
			usage();
			break;
		}
	}
	/* "-d""-e"w肳ĂȂ΁A"-e"Ƃ܂B */
	if(!mode) {
		mode = 'e';
	}
	/* ̓t@C͕K{łB */
	if(!srcname[0]) {
		usage();
	}
	if(mode == 'd') {
//{{2008/11/17:gq".tlz"̎⊮[ύX܂B
//		/* ̓t@C̊gqȗĂA".tlz"Ƃ܂B */
//		_splitpath(srcname, drive, dir, fname, ext);
//		if(!ext[0]) {
//			_makepath(srcname, drive, dir, fname, ".tlz");
//		}
//		/* o̓t@CȗĂA̓t@Cgq菜̂Ƃ܂B */
//		if(!dstname[0]) {
//			_splitpath(srcname, drive, dir, fname, ext);
//			 _makepath(dstname, drive, dir, fname, "");
//		}
//2008/11/17:gq".tlz"̎⊮[ύX܂B
		/* ̓t@C̊gqȗĂA".tlz"Ƃ܂B
		 * - <>
		 *	̓t@C D:\path\fname -> ̓t@C D:\path\fname.tlz
		 */
		_splitpath(srcname, drive, dir, fname, ext);
		if(!ext[0]) {
			_makepath(srcname, drive, dir, fname, ".tlz");
		}
		/* o̓t@CȗĂꍇA
		 * - ̓t@C̊gq".tlz"Ȃ΁A".tlz"菜̂Ƃ܂B
		 * - ̓t@C̊gq".tlz"łȂ΁Ao̓t@C𐄑łȂ̂ŁAG[Ƃ܂B
		 * - <>
		 *	̓t@C D:\path\fname.ext.tlz -> o̓t@C D:\path\fname.ext
		 *	̓t@C D:\path\fname.ext     -> G[
		 */
		if(!dstname[0]) {
			_splitpath(srcname, drive, dir, fname, ext);
			if(!stricmp(ext, ".tlz")) {
				_makepath(dstname, drive, dir, fname, NULL);
			} else {
				fprintf(stderr, "Error: Destination file could not be supposed.\n");
				exit(1);
			}
		}
//}}2008/11/17:gq".tlz"̎⊮[ύX܂B
	}
	if(mode == 'e') {
//{{2008/11/17:gq".tlz"̎⊮[ύX܂B
//		/* o̓t@CȗĂA̓t@C̊gq".tlz"ɂ̂Ƃ܂B */
//		if(!dstname[0]) {
//			_splitpath(srcname, drive, dir, fname, ext);
//			 _makepath(dstname, drive, dir, fname, ".tlz");
//		}
//		/* o̓t@C̊gqȗĂA".tlz"Ƃ܂B */
//		_splitpath(dstname, drive, dir, fname, ext);
//		if(!ext[0]) {
//			_makepath(dstname, drive, dir, fname, ".tlz");
//		}
//2008/11/17:gq".tlz"̎⊮[ύX܂B
		/* o̓t@CȗĂA̓t@CɊgq".tlz"ǉ̂Ƃ܂B
		 * - ̓t@CgqĂꍇǍɂ̊gq".tlz"ǉ܂B
		 *   ̏ꍇAǉgq".tlz"{̊gqɂȂāÅgq̓t@CƂȂ܂B
		 *   <>
		 *	̓t@C D:\path\fname.ext -> o̓t@C D:\path\fname.ext.tlz
		 */
		if(!dstname[0]) {
			_makepath(dstname, NULL, NULL, srcname, ".tlz");
		}
		/* o̓t@C̊gqȗĂA".tlz"Ƃ܂B
		 * - <>
		 *	o̓t@C D:\path\fname -> o̓t@C D:\path\fname.tlz
		 */
		_splitpath(dstname, drive, dir, fname, ext);
		if(!ext[0]) {
			_makepath(dstname, drive, dir, fname, ".tlz");
		}
//}}2008/11/17:gq".tlz"̎⊮[ύX܂B
	}
	/* ̓t@CƏo̓t@CłĂ͂܂B */
	if(!stricmp(srcname, dstname)) {
		fprintf(stderr, "Error: Source file should not be same as destination file.\n");
		exit(1);
	}

	/* ̓t@Cǂݍ݂܂B */
	fp = fopen(srcname, "rb");
	if(!fp) {
		fprintf(stderr, "Error: Failed to open file %s.\n", srcname);
		exit(1);
	}
	fseek(fp, 0, SEEK_END);
	srclen = ftell(fp);
	if(!srclen) {
		fprintf(stderr, "Error: Source file should not be empty.");
		exit(1);
	}
	rewind(fp);
	srcbuf = malloc(srclen);
	if(!srcbuf) {
		fprintf(stderr, "Error: Failed to allocate source buffer.\n");
		exit(1);
	}
	fread(srcbuf, 1, srclen, fp);
	fclose(fp);

	if(mode == 'e') {
		/* kB */
		dstlen = TinyLZ_compress(NULL, 0, srcbuf, srclen);
		dstbuf = malloc(dstlen);
		if(!dstbuf) {
			fprintf(stderr, "Error: Failed to allocate destination buffer.\n");
			exit(1);
		}
		TinyLZ_compress(dstbuf, dstlen, srcbuf, srclen);
		/* xt@CB */
		verbuf = malloc(srclen);
		if(!verbuf) {
			fprintf(stderr, "Error: Failed to allocate verify buffer.\n");
			exit(1);
		}
		verlen = TinyLZ_uncompress(verbuf, srclen, dstbuf, dstlen);
		//{{2009/08/26:TCYrłȂAers悤C
		//if(verlen != srclen) {
		//2009/08/26:TCYrłȂAers悤C
		if((verlen != srclen) || memcmp(verbuf, srcbuf, srclen)) {
		//}}2009/08/26:TCYrłȂAers悤C
			fprintf(stderr, "Internal error: Verify failed.n");
			exit(1);
		}
	}
	if(mode == 'd') {
		/* WJB */
		dstlen = TinyLZ_uncompress(NULL, 0, srcbuf, srclen);
		dstbuf = malloc(dstlen);
		if(!dstbuf) {
			fprintf(stderr, "Error: Failed to allocate destination buffer.\n");
			exit(1);
		}
		TinyLZ_uncompress(dstbuf, dstlen, srcbuf, srclen);
	}

	/* o̓t@C݂܂B */
	fp = fopen(dstname, "wb");
	if(!fp) {
		fprintf(stderr, "Error: Failed to create file %s.\n", dstname);
		exit(1);
	}
	fwrite(dstbuf, 1, dstlen, fp);
	fclose(fp);

	/* |[g\B */
	printf("%s (%d) => %s (%d) : %d%%\n",
		srcname, srclen,
		dstname, dstlen,
		//{{2009/08/06:I[o[t[oOC
		//(dstlen * 100 + srclen - 1) / srclen);
		//2009/08/06:I[o[t[oOC
		(int)ceil((double)dstlen * 100.0 / (double)srclen));
		//}}2009/08/06:I[o[t[oOC

	return 0;
}
